<template>
<div class="notice-page">
  <el-drawer
  title="消息通知"
  :visible.sync="drawer"
  :direction="direction"
  :before-close="handleClose" style="height: 100vh;">
    <div class="head">
      <div class="head-search">
        <label>消息类型：</label>
        <el-select v-model="type" placeholder="请选择" style="width: 150px;" size="small">
        <el-option
          v-for="item in options"
          :key="item.value"
          :label="item.label"
          :value="item.value">
        </el-option>
      </el-select>
      </div>
      <el-dropdown style="margin-right: 20px;">
        <span class="el-dropdown-link">
          <span class="more">&middot;&middot;&middot;</span>
        </span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item>
            <i class="el-icon-check"></i>
            <span>标记所有消息为已读</span>
          </el-dropdown-item>
          <el-dropdown-item>
            <i class="el-icon-delete"></i>
            <span>删除所有已读消息</span>
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
    <div class="notice-content">
      <div class="notice-content-item" v-for="(m,i) in list" :key="i">
        <div class="btns">
          <el-dropdown style="margin-right: 20px;" trigger="click" @command="handleDropdown">
            <span class="el-dropdown-link">
              <span class="more" style="line-height: 26px;display: inline-block;">&middot;&middot;&middot;</span>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item v-for="(n,j) in dropdownList" :key="j" :command="n.value">
                {{ n.label }}
              </el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
          <i class="el-icon-close" style="cursor: pointer;"></i>
        </div>
        <div class="content">
          <img :src="`../../static/img/notice-${m.type}.svg`" alt="" style="width: 50px;margin-right: 18px;">
          <div class="content-info">
            <h4 style="font-weight: normal;margin-bottom: 4px;display: flex;align-items: center;justify-content: space-between;">
              <span>{{ m.title }}</span>
              <span class="time" style="color: #999999;font-size: 12px;">{{ m.time }}</span>
            </h4>
            <p style="color: #999999;font-size: 14px;margin-bottom: 6px;" class="ellipsis-multiline">{{ m.content }}</p>
            <el-tag type="danger" size="small" v-if="m.status==0&&m.type==2" style="margin-bottom: 4px;">已拒绝</el-tag>
            <el-tag type="success" size="small" v-if="m.status==1&&m.type==2" style="margin-bottom: 4px;">已接收</el-tag>
            <p style="font-size: 12px;color: #999999;display: flex;align-items: center;justify-content: space-between;">
              <span>发送人：{{m.sendUser}}</span>
              <span>收件人：{{ m.getUser }}</span>
            </p>
          </div>
        </div>
        <div class="new-notice" v-if="m.isRead==0">
          <span>new</span>
        </div>
      </div>
    </div>
  </el-drawer>
</div>
</template>

<script>
export default {
  data(){
    return{
      drawer:false,
      direction:'rtl',
      options:[],
      type:'0',
      list:[
        {
          type:1,
          title:'标题',
          content:'内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容',
          time:'2019-08-07 15:34:26',
          status:0,//消息状态：拒绝、接收
          isRead:0,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:2,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:1,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:3,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:0,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:4,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:0,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:5,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:0,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:6,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:1,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:6,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:1,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:6,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:1,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:6,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:1,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
        {
          type:6,
          title:'标题',
          content:'内容',
          time:'2019-08-07 15:34:26',
          status:1,//消息状态：拒绝、接收
          isRead:1,//是否已读
          sendUser:'小明',
          getUser:'李华',
        },
      ],
      dropdownList:[
        {
          label:'拒绝',
          value:0
        },
        {
          label:'接收',
          value:1
        },
        {
          label:'通过',
          value:2
        },
        {
          label:'不通过',
          value:3
        },
        {
          label:'批准',
          value:4
        },
        {
          label:'不批准',
          value:5
        },
        {
          label:'查看更多',
          value:6
        },
      ]
    }
  },
  mounted(){
    this.getTypeDicts();
  },
  methods:{
    open(){
      this.drawer = true;
    },
    handleClose(){
      this.drawer = false;
    },
    getTypeDicts() {
      this.$axios.post(this.$api.enums.selectEnumByCategory, {
        category: "消息类型"
      }).then(res => {
        let data = res.data
        this.options = data;
      })
    },
    goNoticeDetail(){
      this.drawer = false;
      this.$parent.addTab({
			v: "消息详情",
			i: "el-icon-s-tools",
			u: "notice-detail",
      k:35,
			p: "abcd"
		},29);
    },
    handleDropdown(e){
      switch(e){
        case 0:
          break;
        case 6:
          this.goNoticeDetail()
          break;
      }
    }
  }
}
</script>

<style scoped>
>>>.el-drawer__header::before {
  content: "";
  display: inline-block;
  width: 4px;
  height: 30.24px;
  background: #3A7BFA;
  border-radius: 10px;
  margin-left: 32px;
  margin-right: 8.5px;
}

>>>.el-drawer__header {
  color: #303133;
}
>>>.el-drawer__body{
  height: calc(100vh - 82px);
  overflow: hidden;
}
.head{
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 16px;
  box-sizing: border-box;
  padding: 0 16px;
}
.more{
  font-size: 20px;
  color: grey !important;
  cursor: pointer;
}
.notice-content{
  height: calc(100% - 60px);
  overflow-y: auto;
  box-sizing: border-box;
  padding: 0 16px;
}
.notice-content-item{
  position: relative;
  width: 100%;
  padding: 8px;
  border-radius: 8px;
  box-sizing: border-box;
  border: 1px solid #EEEEEE;
  margin-bottom: 10px;
  overflow: hidden;
}
.btns{
  position: absolute;
  right: 20px;
  top: 4px;
  z-index: 4;
}
.notice-content-item .btns{
  opacity: 0;
}
.time{
  opacity: 1;
}
.notice-content-item:hover{
  box-shadow: 4px 4px 8px 0px rgba(51,51,51,0.04);
}
.notice-content-item:hover .btns{
  opacity: 1;
}
.notice-content-item:hover .time{
  opacity: 0;
}
.content{
  display: flex;
  align-items: center;
}
.content-info{
  flex: 1;
}
.new-notice{
  position: absolute;
  left: 0;
  top: 0;
  width: 0;
  height: 0;
  border-top: 14px solid red;
  border-right: 14px solid transparent;
  border-bottom: 14px solid transparent;
  border-left: 14px solid red;
}
.new-notice span{
  position: absolute;
  font-size: 12px;
  top: -13px;
  left: -17px;
  color: #fff;
  transform: rotate(-45deg) scale(0.8);
}
</style>
